//       k=1

#include<stdio.h>
#include<string.h>

typedef unsigned char BYTE;	
typedef unsigned long MASK; //  


MASK mask[256]; //    (      ,        )

const char text[]="---abab---abxab---abxyab--";
const char pattern[]="abxab";




//   ( )
bool Init()
{
	int n,len; 
	len=strlen(pattern); if(len>sizeof(MASK)*8) { printf("too big size\n"); return true;}
	for(n=0; n<256; n++) mask[n]=(1<<len)-1;	//    
	for(n=0; pattern[n]; n++) mask[(BYTE)pattern[n]]^=1<<(len-n-1);	//   
	return false;
}

void Show(int pos)
{
	printf("%s\n",text);
	printf("%*s%s\n",pos,"",pattern);
}


void Work()
{
	MASK s1,s2,t; int n,len,i;
	len=strlen(pattern); 
	s1=s2=(1<<len)-1;
	for(n=0; text[n]; n++) {
		t=s1;
		s1=(s1>>1)|mask[text[n]];
		s2=t&(s1>>1)&(t>>1)&((s2>>1)|mask[text[n]]);
		if(!(s2&1)) Show(i=n-len+1);
	}
	printf("[done]\n");
}


void main()
{
	if(Init()) return;
	Work();
	getchar();
}


